<?php require_once('dir.inc.php');

function createContainer($inscription_1, $inscription_2) {
    $toArc = array();
	if($inscription_1 == 1 && $inscription_2 == 0)
	{
		$toArc['abonnement'] = "1";
		$toArc['statut_niv1'] = 1;
	}
	elseif($inscription_1 == 1 && $inscription_2 == 1)
	{
		$toArc['abonnement'] = "1,2,3";
		$toArc['statut_niv1'] = 1;
		$toArc['statut_niv2'] = 4;
	}
	elseif($inscription_1 == 0 && $inscription_2 == 1)
	{
		$toArc['abonnement'] = "1,2,3";
		$toArc['statut_niv1'] = 1;
		$toArc['statut_niv2'] = 4;
	}
    $toArc['email__utilisable'] = "0";
    $toArc['mobile__utilisable'] = "0";
    $interets = array();
    $toArc['centres_interets'] = $interets;
    $toArc['civilite'] = "3";
    $toArc['nom'] = "";
    $toArc['prenom'] = "";
    $toArc['adresse_complete'] = "";
    $toArc['complement_adresse'] = "";
    $toArc['complement_adresse2'] = "";
    $toArc['bp'] = "";
    $toArc['code_postal'] = "";
    $toArc['localite'] = "";
    $toArc['email'] = "r";
    $toArc['mobile'] = "";
    $toArc['changed_val_form'] = "false";
    $toArc['type_contact'] = "1";
    $toArc['id_co'] = "8";
    $toArc['localite__utilisable'] = "0";
    $toArc['pays'] = "France";

    return $toArc;
}

function createJSON ($container, $data) {

    $newsletter = 0;
    $journal = 0;

    foreach ($data as $k=>$v) {
        if ($k == "prenom") $container['prenom'] = $v;
        if ($k == "nom") $container['nom'] = $v;
        if ($k == "adresse") $container['adresse_complete'] = $v;
        if ($k == "cp") $container['code_postal'] = $v;
        if ($k == "ville") $container['localite'] = $v;
        if ($k == "telephone") $container['mobile'] = $v;
        if ($k == "email") $container['email'] = $v;
        if ($k == "thematiques") {
            $thematiques = explode(",", $v);
            $interets = array();
            foreach ($thematiques as $thematique) {
                if ($thematique == "Aménagement du territoire/ruralité") array_push($interets, "11");
                if ($thematique == "Culture") array_push($interets, "13");
                if ($thematique == "Démocratie/vie associative") array_push($interets, "10");
                if ($thematique == "Economie/emploi") array_push($interets, "1");
                if ($thematique == "Education/formation") array_push($interets, "3");
                if ($thematique == "Education supérieure/recherche") array_push($interets, "2");
                if ($thematique == "Europe/International") array_push($interets, "15");
                if ($thematique == "Solidarité/santé") array_push($interets, "12");
                if ($thematique == "Sport") array_push($interets, "14");
                if ($thematique == "Transition énergétique/environnement") array_push($interets, "4");
                if ($thematique == "Transport") array_push($interets, "16");
            }
            $container['centres_interets'] = $interets;
        }
    }

    $json =  json_encode($container);

    return $json;
}

function submitJSON ($params, $json) {

    $data_string = $json;

    $devURL = "https://arc.novagouv.fr/wsa_iform/wsa_iform_new.php?action=enrSondage&cle=&client=earc_campagne_pdl&formulaire=45&id_contact=&id_reponse=&mod=creation&other=&profil=1&type_fusion=indirect";

    $ch = curl_init($devURL);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json',
            'Content-Length: ' . strlen($data_string))
    );
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);


    $output = curl_exec($ch);
    $info = curl_getinfo($ch);
    $error = curl_error($ch);

    curl_close($ch);

    $return['output'] = $output;
    $return['info'] = $info;
    $return['error'] = $error;

    return $return;
}

$error = '';
$error_2 = '';
$error_3 = '';
if(isset($post['statut']) || isset($post['email']))
{
    
      $post['email_parrain'] = $post['email'];
    if($classValidations->checkValidEmail($post[email]))
    {

        //if($get['type'] == 'joinus' && (isset($post['inscription_1']) || isset($post['inscription_2']))) {

            if($post['prenom'] != '' && $post['nom'] != '' && $post['cp'] != '')
            {
                if($get['type'] == 'contact')
                {
                    $classFormulaires->save($post);
					
					if($post['go_to_arc'] != 0 || !isset($post['go_to_arc']))
					{
                    //envoi donnees vers arc
                    $params['url'] = "https://www.operarc.com/wsa_iform/wsa_iform_new.php?action=enrSondage&cle=&client=earc_campagne_pdl&formulaire=45&id_contact=&id_reponse=&mod=creation&other=&profil=1&type_fusion=indirect";
					$toArc = createContainer($post['inscription_1'], $post['inscription_2']);
					$json = createJSON($toArc, $post);
					$result = submitJSON($params, $json);
					}

					$message = 'ok';
                    $destinataire = 'contact@clergeau.com';
                    // Pour les champs $expediteur / $copie / $destinataire, séparer par une virgule s'il y a plusieurs adresses
                    $expediteur = $post['email'];

                    $objet = 'Nouveau message depuis clergeau.com'; // Objet du message
                    $headers  = 'MIME-Version: 1.0' . "\n"; // Version MIME
                    $headers .= 'Reply-To: '.$post['email']."\n"; // Mail de reponse
                    $headers .= 'From: "Nom_de_expediteur"<'.$post['prenom'].''.$post['nom'].'>'."\n"; // Expediteur
                    $headers .= 'Delivered-to: '.$destinataire."\n"; // Destinataire
                    $message = ''.$post['message'].'<br/><br/>';
                    $message .= 'Email : '.$post['email'].'<br/>';
                    $message .= 'Nom : '.$post['nom'].'<br/>';
                    $message .= 'Prenom : '.$post['prenom'].'<br/>';
                    if (mail($destinataire, $objet, $message, $headers)) // Envoi du message
                    {
                    }
                    else // Non envoyé
                    {
                    }
                }
                else
                {
                    if(!isset($get['type']) && $post['thematiques'] == '')
                    {
                        $error_3 = "Veuillez renseigner au moins une thématique";
                    }
                    else
                    {
                        $classFormulaires->save($post);
						
						if($post['go_to_arc'] != 0 || !isset($post['go_to_arc']))
						{
                        //envoi donnees vers arc
                        $params['url'] = "https://www.operarc.com/wsa_iform/wsa_iform_new.php?action=enrSondage&cle=&client=earc_campagne_pdl&formulaire=45&id_contact=&id_reponse=&mod=creation&other=&profil=1&type_fusion=indirect";
                        $toArc = createContainer($post['inscription_1'], $post['inscription_2']);
                        $json = createJSON($toArc, $post);
                        $result = submitJSON($params, $json);

                        $message = 'ok';
						}
                    }
                }
            }
            else
            {
                $error_2 = "Code postal, nom ou prénom non renseignés";
            }

        //}
        //else {
         //   $error = "Mode de participation non renseigné";
        //}

    }
    else
    {
        $error = "Adresse e-mail incorrecte";
        $error_mail = "Adresse e-mail incorrecte";
        if ($get['type'] == 'joinus' && (!isset($post['inscription_1']) && !isset($post['inscription_2']))) {
            $error = $error . "<br />Mode de participation non renseigné";
        }
    }  
}
?>
    <!doctype html>
    <html lang="fr">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="initial-scale=1.0">
    <title></title>
    <meta name="description" content="">
    <meta name="keywords" content="">
    <meta name="author" content="">
    <meta name="robots" content="index,follow">
	<script type="text/javascript">
		function recherche_cities()
		{
			terme = document.getElementById('recherche_cities_input').value;
			div = "recherche_cities_block";
			data = "recherche=" + terme;
			AAWrite2('recherche_cities.php', data, 'div', div);
			$('#recherche_cities_block').css('display', 'block');
		}

		function complete_city(cp, nom)
		{
			document.getElementById("recherche_cities_input").value=cp;
			document.getElementById("recherche_cities_name").value=nom;
			$('#recherche_cities_block').css('display', 'none');
		}
		
	/**
	AnAA - Ajax Framework
	Version 1.8
	www.leslignesclaires.fr
	(c) 2007-2015 Matthieu Requenna.
	Free under the GNU GPL 2.0 Licence.
	*/

	var AACaching = false;


	function AACreate()
	{
		var request = false;
			try {
				request = new ActiveXObject('Msxml2.XMLHTTP');
			}
			catch (err2) {
				try {
					request = new ActiveXObject('Microsoft.XMLHTTP');
				}
				catch (err3) {
			try {
				request = new XMLHttpRequest();
			}
			catch (err1)
			{
				request = false;
			}
			}
		}
		return request;
	}


	/**
		AA Read
		Load a file, text or XML
	*/

	function AARead(url, fun, element)
	{
		var xhr = AACreate();
		var ext = url.substr(url.length - 3);
		var isXML =  (ext == "xml");

		xhr.onreadystatechange=function()
		{
			if(xhr.readyState == 4)
			{
				if(xhr.status == 200)
				{
					var content;
					if(isXML)
						content = xhr.responseXML;
					else
						content = xhr.responseText;
					fun(content, element);
				}
			}
		};

		if(AACaching == false)
			url = url + "?nocache=" + Math.random();
		xhr.open("GET", url , true);
		xhr.send(null);
	}

	/**
		Read an XML file with any extension
	*/

	function AALoadXML(url, fun, element)
	{
		var xhr = AACreate();
		xhr.onreadystatechange=function()
		{
			if(xhr.readyState == 4)
			{
				fun(xhr.responseXML, element);
			}
		};
		xhr.open("GET", url , true);
		xhr.send(null);
	}

	/**
		AAWrite
		url:	the script
		data:	the string to pass to the script
			it is a list of pairs x=y separated by &
	*/

	function AAWrite(url, data, fun)
	{
		var xhr = AACreate();

		xhr.onreadystatechange=function()
		{
			if(xhr.readyState == 4)
			{
				if(fun != null) fun(xhr.responseText);
			}
		};
		xhr.open("POST", url, true);
		xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		xhr.send(data);
	}


	function AAGetBody(content)
	{
		var x = content.indexOf("<body");
		if(x == -1) return "";

		x = content.indexOf(">", x);
		if(x == -1) return "";

		var y = content.lastIndexOf("</body>");
		if(y == -1) return "";

		return content.slice(x + 1, y);
	}

	function AAPutHTML(content, target)
	{
		target.innerHTML = AAGetBody(content);
	}

	/**
		Loads a HTML page
		Put the content of the body tag into the current page.
		Arguments:
			url of the other HTML page to load
			id of the tag that has to hold the content
	*/

	function AALoadHTML(url, fun, storage, param)
	{
		var xhr = AACreate();
		xhr.onreadystatechange=function()
		{
			if(xhr.readyState == 4)
			{
				if(xhr.status == 200)
				{
					storage = document.getElementById(storage);
					storage.innerHTML = AAGetBody(xhr.responseText);
					fun(storage, param);
				}
			}
		};

		if(AACaching == false)
			url = url + "?nocache=" + Math.random();
		xhr.open("GET", url , true);
		xhr.send(null);

	}


	/**
		Send a HEAD request,
		call a function with the value
	*/

	function AAHead(url, key, fun, element)
	{
		var xhr = AACreate();

		xhr.onreadystatechange = function()
		{
			if(xhr.readyState == 4)
			{
				var value;
				if (xhr.status == 200)
				{
					 value = xhr.getResponseHeader(key);
				}
				else
				{
					if(xhr.status==404)
						value = url + " doesn't exist!";
					else
						value = "Error, status is " + xhr.status;
				}
				fun(value, element);
			}
		}
		xhr.open("HEAD", url, true);
		xhr.send(null);
	}


	function AAWrite2(url, data, type, divfun)
	{
		var xhr = AACreate();

		xhr.onreadystatechange=function()
		{
			if(xhr.readyState == 4)
			{
				if(type == 'div')
				{
					element = document.getElementById(divfun);
					element.innerHTML = xhr.responseText;
				}
				else
				{
					// alert('DIRECT : ' + xhr.responseText);
					divfun(xhr.responseText);
				}
			}
		};
		xhr.open("POST", url, true);
		xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		xhr.send(data);
	}	
	</script>
	<link href='https://fonts.googleapis.com/css?family=Montserrat' rel='stylesheet' type='text/css'>
    <?php include(''.$DIR.'templates/_'.$TEMPLATE.'/includes/header.inc.php'); ?>
    <div class="wrapper">
        <?php if(!isset($post['email']) || $error != '' || $error_2 !='' || $error_3 != '')
        {
            ?>
            <?php if(!isset($get['type']))
        {
            ?>
            <form action="index.php?champ_invitation=0" method="POST">
                <div class="label_topic"><center><?php echo $error; ?> <?php echo $error_2; ?> <?php echo $error_3; ?></center></div>
                <?php if(!isset($get['champ_coordonnees'])) { ?>
                    <div class="label_topic">Coordonnées</div>
                    <div class="relatif">
                        <div class="grid_50 left">
                            <input type="text" placeholder="Prénom" value="<?php echo $post['prenom']; ?>" name="prenom" />
                        </div>
                        <div class="grid_50 right">
                            <input type="text" placeholder="Nom" value="<?php echo $post['nom']; ?>" name="nom" />
                        </div>
                        <div class="grid_50 left">
                            <input type="text" placeholder="Code postal (obligatoire)" value="<?php echo $post['cp']; ?>" name="cp" id="recherche_cities_input" onKeyUp="recherche_cities();"/>
							<div id="recherche_cities_block" style="display: none; position: absolute; width: 100%; z-index: 50;"></div>
						</div>
                        <div class="grid_50 right">
                            <input type="text" placeholder="Ville" value="<?php echo $post['ville']; ?>" name="ville" id="recherche_cities_name"/>
                        </div>
						<div class="grid_50 left">
                            <input type="text" placeholder="Adresse e-mail (obligatoire)" value="<?php echo $post['email']; ?>" name="email" />
						</div>
                        <div class="grid_50 right">
                            <input type="text" placeholder="N° de téléphone mobile (facultatif)" value="<?php echo $post['telephone']; ?>" name="telephone" />
                        </div>
           
                    </div>
                <?php } ?>

                

                <?php if(!isset($get['champ_thematique'])) { ?>
                    <script type="text/javascript">

                        function check_all(id_thema)
                        {
							var to_deploy = "#deploycat_" + id_thema;
                            var groupe_thema = "#" + id_thema + "_";
                            var groupe_thema_js = id_thema + "_";

                            var big_thema = "#" + id_thema;

                            var s_thema_1 = groupe_thema + "1";
                            var s_thema_2 = groupe_thema + "2";
                            var s_thema_3 = groupe_thema + "3";

                            var s_thema_1_js = groupe_thema_js + "1";
                            var s_thema_2_js = groupe_thema_js + "2";
                            var s_thema_3_js = groupe_thema_js + "3";
                            if($(big_thema).is(':checked') == true)
                            {
                                if(id_thema == "thema_2")
                                {
                                    $(s_thema_1).prop( "checked", true );
                                    $(s_thema_2).prop( "checked", true );

                                    auto_thema(s_thema_1_js);
                                    auto_thema(s_thema_2_js);
									$(to_deploy).fadeToggle("slow", "linear");
                                }
                                if(id_thema == "thema_4" || id_thema == "thema_5")
                                {
                                    $(s_thema_1).prop( "checked", true );
                                    $(s_thema_2).prop( "checked", true );
                                    $(s_thema_3).prop( "checked", true );

                                    auto_thema(s_thema_1_js);
                                    auto_thema(s_thema_2_js);
                                    auto_thema(s_thema_3_js);
									$(to_deploy).fadeToggle("slow", "linear");
                                }

                            }
                            if($(big_thema).is(':checked') == false)
                            {
                                if(id_thema == "thema_2")
                                {
                                    $(s_thema_1).prop( "checked", false );
                                    $(s_thema_2).prop( "checked", false );

                                    auto_thema(s_thema_1_js);
                                    auto_thema(s_thema_2_js);
                                }
                                if(id_thema == "thema_4" || id_thema == "thema_5")
                                {
                                    $(s_thema_1).prop( "checked", false );
                                    $(s_thema_2).prop( "checked", false );
                                    $(s_thema_3).prop( "checked", false );

                                    auto_thema(s_thema_1_js);
                                    auto_thema(s_thema_2_js);
                                    auto_thema(s_thema_3_js);
                                }

                            }
                        }
                        function auto_thema(id_thema)
                        {
                            var thema_clic = "#" + id_thema;
                            var contenu_thema = $(thema_clic).val() + ",";
                            var contenu_ec = $("#thematiques").val();
                            if($(thema_clic).is(':checked') == true)
                            {
                                var contenu_final = contenu_ec + contenu_thema;
                                $("#thematiques").val(contenu_final);

                            }
                            else
                            {
                                var maChaine = contenu_ec;
                                var chaineASupprimer = contenu_thema;
                                var maChaine = maChaine.replace(chaineASupprimer, "");
                                $("#thematiques").val(maChaine);

                            }
                        }
                    </script>
                    <div class="label_topic">Thématiques</div>

                    <div class="checkboxes">
                        <input type="checkbox" id="thema_1_1" value="Economie/emploi" onclick="auto_thema(this.id);" /> Economie/emploi
                    </div>

                    <div class="checkboxes">
                        <input type="checkbox" id="thema_2" value="Formation" onclick="check_all(this.id);" /> Formation
                    </div>
					<div id="deploycat_thema_2" style="display: none;">
						<div class="checkboxes enfant">
							<input type="checkbox" id="thema_2_1" value="Education supérieure/recherche" onclick="auto_thema(this.id);" /> Education supérieure/recherche
						</div>
						<div class="checkboxes enfant">
							<input type="checkbox" id="thema_2_2" value="Education/formation" onclick="auto_thema(this.id);" /> Education/formation
						</div>
					</div>


                    <div class="checkboxes">
                        <input type="checkbox" id="thema_3_1" value="Transition énergétique/environnement" onclick="auto_thema(this.id);" /> Transition énergétique/environnement
                    </div>

                    <div class="checkboxes">
                        <input type="checkbox" id="thema_4" value="Animer la démocratie , développer les territoires" onclick="check_all(this.id);" /> Animer la démocratie , développer les territoires
                    </div>
					
					<div id="deploycat_thema_4" style="display: none;">
						<div class="checkboxes enfant">
							<input type="checkbox" id="thema_4_1" value="Démocratie/vie associative" onclick="auto_thema(this.id);" /> Démocratie/vie associative
						</div>
						<div class="checkboxes enfant">
							<input type="checkbox" id="thema_4_2" value="Aménagement du territoire/ruralité" onclick="auto_thema(this.id);" /> Aménagement du territoire/ruralité
						</div>
						<div class="checkboxes enfant">
							<input type="checkbox" id="thema_4_3" value="Transport" onclick="auto_thema(this.id);" /> Transport
						</div>
					</div>	

                    <div class="checkboxes">
                        <input type="checkbox" id="thema_5" value="Economie" onclick="check_all(this.id);" />Vivre ensemble solidaires
                    </div>
					
					<div id="deploycat_thema_5" style="display: none;">
                    <div class="checkboxes  enfant">
                        <input type="checkbox" id="thema_5_1" value="Solidarité/santé" onclick="auto_thema(this.id);" /> Solidarité/santé
                    </div>
					
					
						<div class="checkboxes  enfant">
							<input type="checkbox" id="thema_5_2" value="Culture" onclick="auto_thema(this.id);" /> Culture
						</div>
						<div class="checkboxes enfant">
							<input type="checkbox" id="thema_5_3" value="Sport" onclick="auto_thema(this.id);" /> Sport
						</div>
					</div>
						<div class="checkboxes">
							<input type="checkbox" id="thema_6" value="Europe/International" onclick="auto_thema(this.id);" /> Europe/International
						</div>
						
                <?php } ?>

                <!-- Eric -->

                <div class="label_topic">Inscriptions</div>
                <div class="checkboxes">
					<input type="hidden" name="inscription_1" value="0" />
					<input type="hidden" name="inscription_2" value="0" />
                    <input type="checkbox" name="inscription_1" value="1" checked/>  Je souhaite être informé de la campagne de Christophe Clergeau
                </div>
                <div class="checkboxes">
                    <input type="checkbox" name="inscription_2" value="1" checked/>  Je souhaite rejoindre l'équipe et participer à la campagne de Christophe Clergeau
                </div>

                <!-- Eric -->

                <br/>
                <div class="grid_100">

                    <?php if(!isset($get['champ_invitation'])) { ?>
                        <div class="label_topic">Inviter des amis</div>
                        <input type="text" placeholder="E-mail ami 1" value="<?php echo $post['emailami1']; ?>" name="emailami1" />
                        <input type="text" placeholder="E-mail ami 2" value="<?php echo $post['emailami2']; ?>" name="emailami2" />
                        <input type="text" placeholder="E-mail ami 3" value="<?php echo $post['emailami3']; ?>" name="emailami3" />
                    <?php } ?>
                    <center><input type="submit" class="submit_b" value="VALIDER" /></center>
                </div>

                <input type="hidden" name="statut" value="1" />
                <input type="hidden" name="thematiques" value="" id="thematiques" />
            </form>
        <?php
        }
        elseif($get['type'] == 'joinus')
        {
        ?>
            <form action="index.php?type=joinus" method="POST">
                <div class="label_topic"><center><?php echo $error; ?> <?php echo $error_2; ?> <?php echo $error_3; ?></center></div>
                <?php if(!isset($get['champ_coordonnees'])) { ?>
                    <div class="label_topic">Coordonnées</div>
                    <div class="relatif">
                        <div class="grid_50 left">
                            <input type="text" placeholder="Prénom" value="<?php echo $post['prenom']; ?>" name="prenom" />
                        </div>
                        <div class="grid_50 right">
                            <input type="text" placeholder="Nom" value="<?php echo $post['nom']; ?>" name="nom" />
                        </div>

                        <div class="grid_50 left">
                            <input type="text" placeholder="Code postal (obligatoire)" value="<?php echo $post['cp']; ?>" name="cp" id="recherche_cities_input" onKeyUp="recherche_cities();"/>
							<div id="recherche_cities_block" style="display: none; position: absolute; width: 100%; z-index: 50;"></div>
                        </div>
                        <div class="grid_50 right">
                            <input type="text" placeholder="Ville" value="<?php echo $post['ville']; ?>" name="ville" id="recherche_cities_name"/>
                        </div>
                        <div class="grid_50 left">
                            <input type="text" placeholder="Adresse e-mail (obligatoire)" value="<?php echo $post['email']; ?>" name="email" />
						</div>
                        <div class="grid_50 right">
                            <input type="text" placeholder="N° de téléphone mobile (facultatif)" value="<?php echo $post['telephone']; ?>" name="telephone" />
                        </div>
                    </div>
                <?php } ?>

                

                <?php if(!isset($get['champ_thematique'])) { ?>
                    <script type="text/javascript">

                        function check_all(id_thema)
                        {
							var to_deploy = "#deploycat_" + id_thema;
                            var groupe_thema = "#" + id_thema + "_";
                            var groupe_thema_js = id_thema + "_";

                            var big_thema = "#" + id_thema;

                            var s_thema_1 = groupe_thema + "1";
                            var s_thema_2 = groupe_thema + "2";
                            var s_thema_3 = groupe_thema + "3";

                            var s_thema_1_js = groupe_thema_js + "1";
                            var s_thema_2_js = groupe_thema_js + "2";
                            var s_thema_3_js = groupe_thema_js + "3";
                            if($(big_thema).is(':checked') == true)
                            {
                                if(id_thema == "thema_2")
                                {
                                    $(s_thema_1).prop( "checked", true );
                                    $(s_thema_2).prop( "checked", true );

                                    auto_thema(s_thema_1_js);
                                    auto_thema(s_thema_2_js);
									$(to_deploy).fadeToggle("slow", "linear");
                                }
                                if(id_thema == "thema_4" || id_thema == "thema_5")
                                {
                                    $(s_thema_1).prop( "checked", true );
                                    $(s_thema_2).prop( "checked", true );
                                    $(s_thema_3).prop( "checked", true );

                                    auto_thema(s_thema_1_js);
                                    auto_thema(s_thema_2_js);
                                    auto_thema(s_thema_3_js);
									$(to_deploy).fadeToggle("slow", "linear");
                                }

                            }
                            if($(big_thema).is(':checked') == false)
                            {
                                if(id_thema == "thema_2")
                                {
                                    $(s_thema_1).prop( "checked", false );
                                    $(s_thema_2).prop( "checked", false );

                                    auto_thema(s_thema_1_js);
                                    auto_thema(s_thema_2_js);
                                }
                                if(id_thema == "thema_4" || id_thema == "thema_5")
                                {
                                    $(s_thema_1).prop( "checked", false );
                                    $(s_thema_2).prop( "checked", false );
                                    $(s_thema_3).prop( "checked", false );

                                    auto_thema(s_thema_1_js);
                                    auto_thema(s_thema_2_js);
                                    auto_thema(s_thema_3_js);
                                }

                            }
                        }
                        function auto_thema(id_thema)
                        {
                            var thema_clic = "#" + id_thema;
                            var contenu_thema = $(thema_clic).val() + ",";
                            var contenu_ec = $("#thematiques").val();
                            if($(thema_clic).is(':checked') == true)
                            {
                                var contenu_final = contenu_ec + contenu_thema;
                                $("#thematiques").val(contenu_final);

                            }
                            else
                            {
                                var maChaine = contenu_ec;
                                var chaineASupprimer = contenu_thema;
                                var maChaine = maChaine.replace(chaineASupprimer, "");
                                $("#thematiques").val(maChaine);

                            }
                        }
                    </script>
                    <div class="label_topic">Thématiques</div>

                    <div class="checkboxes">
                        <input type="checkbox" id="thema_1_1" value="Economie/emploi" onclick="auto_thema(this.id);" /> Economie/emploi
                    </div>

                    <div class="checkboxes">
                        <input type="checkbox" id="thema_2" value="Formation" onclick="check_all(this.id);" /> Formation
                    </div>
					<div id="deploycat_thema_2" style="display: none;">
						<div class="checkboxes enfant">
							<input type="checkbox" id="thema_2_1" value="Education supérieure/recherche" onclick="auto_thema(this.id);" /> Education supérieure/recherche
						</div>
						<div class="checkboxes enfant">
							<input type="checkbox" id="thema_2_2" value="Education/formation" onclick="auto_thema(this.id);" /> Education/formation
						</div>
					</div>


                    <div class="checkboxes">
                        <input type="checkbox" id="thema_3_1" value="Transition énergétique/environnement" onclick="auto_thema(this.id);" /> Transition énergétique/environnement
                    </div>

                    <div class="checkboxes">
                        <input type="checkbox" id="thema_4" value="Animer la démocratie , développer les territoires" onclick="check_all(this.id);" /> Animer la démocratie , développer les territoires
                    </div>
					
					<div id="deploycat_thema_4" style="display: none;">
						<div class="checkboxes enfant">
							<input type="checkbox" id="thema_4_1" value="Démocratie/vie associative" onclick="auto_thema(this.id);" /> Démocratie/vie associative
						</div>
						<div class="checkboxes enfant">
							<input type="checkbox" id="thema_4_2" value="Aménagement du territoire/ruralité" onclick="auto_thema(this.id);" /> Aménagement du territoire/ruralité
						</div>
						<div class="checkboxes enfant">
							<input type="checkbox" id="thema_4_3" value="Transport" onclick="auto_thema(this.id);" /> Transport
						</div>
					</div>	

                    <div class="checkboxes">
                        <input type="checkbox" id="thema_5" value="Economie" onclick="check_all(this.id);" /> Vivre ensemble solidaires
                    </div>
					
					<div id="deploycat_thema_5" style="display: none;">
                    <div class="checkboxes  enfant">
                        <input type="checkbox" id="thema_5_1" value="Solidarité/santé" onclick="auto_thema(this.id);" /> Solidarité/santé
                    </div>
					
					
						<div class="checkboxes  enfant">
							<input type="checkbox" id="thema_5_2" value="Culture" onclick="auto_thema(this.id);" /> Culture
						</div>
						<div class="checkboxes enfant">
							<input type="checkbox" id="thema_5_3" value="Sport" onclick="auto_thema(this.id);" /> Sport
						</div>
					</div>
						<div class="checkboxes">
							<input type="checkbox" id="thema_6" value="Europe/International" onclick="auto_thema(this.id);" /> Europe/International
						</div>
                <?php } ?>

                <!-- Eric -->

                <div class="label_topic">Inscriptions *</div>
                <div class="checkboxes">
					<input type="hidden" name="inscription_1" value="0" />
					<input type="hidden" name="inscription_2" value="0" />
                    <input type="checkbox" name="inscription_1" value="1" checked/>  Je souhaite être informé de la campagne de Christophe Clergeau
                </div>
                <div class="checkboxes">
                    <input type="checkbox" name="inscription_2" value="1" checked/>  Je souhaite rejoindre l'équipe et participer à la campagne de Christophe Clergeau
                </div>

                <!-- Eric -->

                <br/>
                <div class="grid_100">
                    <!--
                    <?php if(!isset($get['champ_invitation'])) { ?>
                        <div class="label_topic">Inviter des amis</div>
                        <input type="text" placeholder="E-mail ami 1" value="<?php echo $post['emailami1']; ?>" name="emailami1" />
                        <input type="text" placeholder="E-mail ami 2" value="<?php echo $post['emailami2']; ?>" name="emailami2" />
                        <input type="text" placeholder="E-mail ami 3" value="<?php echo $post['emailami3']; ?>" name="emailami3" />
                    <?php } ?>
                    -->
                    <center><input type="submit" class="submit_b" value="VALIDER" /></center>
                </div>

                <input type="hidden" name="statut" value="1" />
                <input type="hidden" name="thematiques" value="" id="thematiques" />
            </form>
        <?php
        }
        elseif($get['type'] == 'large')
        {
        ?>
            <form action="index.php" method="POST">
                <div class="label_topic"><center><?php echo $error; ?> <?php echo $error_2; ?></center></div>
                <?php if(!isset($get['champ_coordonnees'])) { ?>
                    <div class="label_topic">Coordonnées</div>
                    <div class="relatif">
                        <div class="grid_100">
                            <input type="text" placeholder="Prénom" value="" name="prenom" />
                            <input type="text" placeholder="Nom" value="" name="nom" />
                            <input type="text" placeholder="Code postal (obligatoire)" value="" name="cp" id="recherche_cities_input" onKeyUp="recherche_cities();"/>*
                            <div id="recherche_cities_block" style="display: none; position: absolute; width: 100%; z-index: 50;"></div>
							<input type="text" placeholder="Ville" value="" name="ville" id="recherche_cities_name"/>
                            <input type="text" placeholder="N° de téléphone" value="" name="telephone" />
                        </div>
                    </div>
                <?php } ?>

                <?php if(!isset($get['champ_email'])) { ?>
                    <div class="grid_100">
                        <div class="label_topic">E-mail *</div>
                        <input type="text" placeholder="Adresse e-mail (obligatoire)" value="" name="email" />
                    </div>
                <?php } ?>

                <div class="grid_100">
                    <?php if(!isset($get['champ_thematique'])) { ?>
                        <div class="label_topic">Thématiques</div>
                        <div class="checkboxes">
                            <input type="checkbox" name="Economie et emploi" value="Economie et emploi"> économie et emploi
                        </div>
                        <div class="checkboxes">
                            <input type="checkbox" name="Formation" value="Formation"> Formation
                        </div>
                        <div class="checkboxes">
                            <input type="checkbox" name="Environnement" value="Environnement"> Environnement
                        </div>
                        <div class="checkboxes">
                            <input type="checkbox" name="Démocratie et territoire" value="Démocratie et territoire"> Démocratie et territoire
                        </div>
                        <div class="checkboxes">
                            <input type="checkbox" name="Solidarité" value="Solidarité"> SOLIDARITé
                        </div>
                    <?php } ?>

                    <!-- Eric -->

                <div class="label_topic">Inscriptions</div>
                <div class="checkboxes">
					<input type="hidden" name="inscription_1" value="0" />
					<input type="hidden" name="inscription_2" value="0" />
                    <input type="checkbox" name="inscription_1" value="1" checked/>  Je souhaite être informé de la campagne de Christophe Clergeau
                </div>
                <div class="checkboxes">
                    <input type="checkbox" name="inscription_2" value="1" checked/>  Je souhaite rejoindre l'équipe et participer à la campagne de Christophe Clergeau
                </div>

                <!-- Eric -->

                    <?php if(!isset($get['champ_invitation'])) { ?>
                        <div class="label_topic">Inviter des amis</div>
                        <input type="text" placeholder="E-mail ami 1" value="" name="emailami1" />
                        <input type="text" placeholder="E-mail ami 2" value="" name="emailami2" />
                        <input type="text" placeholder="E-mail ami 3" value="" name="emailami3" />
                    <?php } ?>
                    <center><input type="submit" class="submit_b" value="VALIDER" /></center>
                </div>
                <input type="hidden" name="statut" value="1" />
            </form>
        <?php
        }
        elseif($get['type'] == 'invitation')
        {
        ?>
            <form action="index.php?type=invitation" method="POST">
                <div class="label_topic"><center><?php echo $error; ?> <?php echo $error_2; ?></center></div>
                <div class="label_topic">Coordonnées</div>
                <div class="relatif">
                    <div class="grid_50 left">
                        <input type="text" placeholder="Prénom" value="<?php echo $post['prenom']; ?>" name="prenom" />
                    </div>
                    <div class="grid_50 right">
                        <input type="text" placeholder="Nom" value="<?php echo $post['nom']; ?>" name="nom" />
                    </div>
                    <div class="grid_50 left">
                        <input type="text" placeholder="Code postal (obligatoire)" value="<?php echo $post['cp']; ?>" name="cp" id="recherche_cities_input" onKeyUp="recherche_cities();"/>
						<div id="recherche_cities_block" style="display: none; position: absolute; width: 100%; z-index: 50;"></div>
					</div>
                    <div class="grid_50 right">
                        <input type="text" placeholder="Ville" value="<?php echo $post['ville']; ?>" name="ville" id="recherche_cities_name"/>
                    </div>
                    <div class="grid_100">
                        <input type="text" placeholder="N° de téléphone mobile (facultatif)" value="<?php echo $post['telephone']; ?>" name="telephone" />
                    </div>
                </div>

								
                
                <?php if(!isset($get['champ_email'])) { ?>
                    <div class="grid_100">
                        <div class="label_topic">E-mail *</div>
                        <input type="text" placeholder="Adresse e-mail (obligatoire)" value="<?php echo $post['email']; ?>" name="email" />
                    </div>
                <?php } ?>

                <!-- Eric -->

                <div class="label_topic">Inscriptions</div>
                <div class="checkboxes">
					<input type="hidden" name="inscription_1" value="0" />
					<input type="hidden" name="inscription_2" value="0" />
                    <input type="checkbox" name="inscription_1" value="1" checked/>  Je souhaite être informé de la campagne de Christophe Clergeau
                </div>
                <div class="checkboxes">
                    <input type="checkbox" name="inscription_2" value="1" checked/>  Je souhaite rejoindre l'équipe et participer à la campagne de Christophe Clergeau
                </div>

                <!-- Eric -->

                <div class="grid_100">
                    <div class="label_topic">Inviter des amis</div>
                    <input type="text" placeholder="E-mail ami 1" value="<?php echo $post['emailami1']; ?>" name="emailami1" />
                    <input type="text" placeholder="E-mail ami 2" value="<?php echo $post['emailami2']; ?>" name="emailami2" />
                    <input type="text" placeholder="E-mail ami 3" value="<?php echo $post['emailami3']; ?>" name="emailami3" />
                    <center><input type="submit" class="submit_b" value="VALIDER" /></center>
                </div>
                <input type="hidden" name="statut" value="1" />
            </form>
        <?php
        }
        elseif($get['type'] == 'cover')
        {
        ?>
            <form action="index.php?type=cover" method="POST">
                <?php if(!isset($get['champ_email'])) { ?>
                    <div class="relatif">
												<div class="grid_50 left">
                            <input type="text" class="cover_i" placeholder="<?php echo $error_2; ?> Prénom" value="<?php echo $post['prenom']; ?>" name="prenom" />
                        </div>
                        <div class="grid_50 right">
                            <input type="text" class="cover_i" placeholder="<?php echo $error_2; ?> Nom" value="<?php echo $post['nom']; ?>" name="nom" />
                        </div>
                        
                    </div>

                    <div class="relatif">
                        <div class="grid_50 left">
                            <input type="text" class="cover_i" placeholder="Code postal (obligatoire)" value="<?php echo $post['cp']; ?>" name="cp" id="recherche_cities_input" onKeyUp="recherche_cities();"/>
							<div id="recherche_cities_block" style="display: none; position: absolute; width: 100%; z-index: 50;"></div>
						</div>
                        <div class="grid_50 right">
                            <input type="text" class="cover_i" placeholder="Ville" value="<?php echo $post['ville']; ?>" name="ville" id="recherche_cities_name"/>
                        </div>
                    </div>
                    <div class="grid_100">
                        <input type="text" class="cover_i" placeholder="<?php echo $error; ?> Adresse e-mail" value="" name="email" />
                    </div>
                <?php } ?>
                <center><input type="submit" class="submit_c" value="RESTEZ INFORMÉ" /></center>
                <input type="hidden" name="statut" value="1" />
                <input type="hidden" name="inscription_1" value="1"/>
                <input type="hidden" name="inscription_2" value="0" />
            </form>
        <?php
        }
        elseif($get['type'] == 'contribution')
        {
        ?>
            <script type="text/javascript">
                function validateEmail(sEmail) {
                    var filter = /^[\w\-\.\+]+\@[a-zA-Z0-9\.\-]+\.[a-zA-z0-9]{2,4}$/;
                    if (filter.test(sEmail)) {
                        return true;
                    }
                    else {
                        return false;
                    }
                }

                function valid_formulaire()
                {
                    //VERIF CHAMP NOM
                    if($("#entry_797512346").val()=="")
                    {
                        alert('Merci de renseigner votre nom');
                    }
                    else
                    {
                        //VERIF CHAMP PRENOM
                        if($("#entry_1488305638").val()=="")
                        {
                            alert('Merci de renseigner votre prénom');
                        }
                        else
                        {
                            //VERIF CHAMP MAIL
                            var sEmail = $("#entry_16618655").val();
                            if($("#entry_16618655").val()=="" || validateEmail(sEmail) == false)
                            {
                                alert('Merci de renseigner votre adresse e-mail/une adresse e-mail valide');
                            }
                            else
                            {
                                if($("#entry_1849195029").val()=="")
                                {
                                    alert('Votre contribution semble vide, merci de remplir le champs afférent.');
                                }
                                else
                                {
                                    alert('Votre contribution nous a été remise avec succès. Merci et à bientôt.');
                                    document.googleformm.submit();
									
									var url = "ajax_contrib.php";
									var div = "ajax_contrib";
									
									var prenom = $("#entry_1488305638").val();
									var nom = $("#entry_797512346").val();
									var email = $("#entry_16618655").val();
									var thematiques = $("#entry_1308851286").val();
									
									if($("#inscription_1").is(':checked') == true)
									{
										var inscription_1 = 1;
									}
									else
									{
										var inscription_1 = 0;
									}	
									if($("#inscription_2").is(':checked') == true)
									{
										var inscription_2 = 1;
									}
									else
									{
										var inscription_2 = 0;
									}	
									
									var data = "prenom=" + prenom + "&nom=" + nom + "&email=" + email + "&inscription_1=" + inscription_1 + "&inscription_2=" + inscription_2 + "&thematiques=" + thematiques;
									AAWrite2(url, data, 'div', div);                                }

                            }
                        }
                    }
                }

                function auto_thema(id_thema)
                {
                    var thema_clic = "#" + id_thema;
                    if($(thema_clic).is(':checked') == true)
                    {
                        var contenu_thema = $(thema_clic).val();
                        var contenu_final = contenu_thema;
                        $("#entry_1308851286").val(contenu_final);
                    }
                }
            </script>
            <form action="https://docs.google.com/forms/d/1JbDmx0ae3iOyMtwbgZMU7HNdoPBKly-camJICYbyFtM/formResponse" method="POST" id="ss-form" name="googleformm" target="googleform">
                <div class="label_topic">Coordonnées</div>
                <div class="relatif">
                    <div class="grid_100">
                        <div class="grid_50 left">
                            <input type="text" placeholder="Prénom" value="" name="entry.1488305638" id="entry_1488305638" />
                        </div>
                        <div class="grid_50 right">
                            <input type="text" placeholder="Nom" value="" name="entry.797512346" id="entry_797512346"/>
                        </div>
                    </div>
                </div>

                <div class="grid_100">
                    <div class="label_topic">E-mail *</div>
                    <input type="text" placeholder="Adresse e-mail (obligatoire)" value="" name="entry.16618655" id="entry_16618655"/>
                </div>

                <div class="label_topic">Thématiques</div>
                <div class="checkboxes">
                    <input type="radio" name="themachamps" id="thema_1" value="Economie/emploi" onclick="auto_thema(this.id);" checked> Economie/emploi
                </div>
                <div class="checkboxes">
                    <input type="radio" name="themachamps" id="thema_2" value="Education/formation" onclick="auto_thema(this.id);" > Education/formation
                </div>
                <div class="checkboxes">
                    <input type="radio" name="themachamps" id="thema_3" value="Transition énergétique/environnement" onclick="auto_thema(this.id);"> TRANSITION ÉNERGÉTIQUE/ENVIRONNEMENT
                </div>
                <div class="checkboxes">
                    <input type="radio" name="themachamps" id="thema_4" value="Démocratie/vie associative" onclick="auto_thema(this.id);"> ANIMER LA DÉMOCRATIE , DÉVELOPPER LES TERRITOIRES
                </div>
                <div class="checkboxes">
                    <input type="radio" name="themachamps" id="thema_5" value="Solidarité/santé" onclick="auto_thema(this.id);"> VIVRE ENSEMBLE SOLIDAIRES
                </div>
                <div class="checkboxes">
                    <input type="radio" name="themachamps" id="thema_6" value="Europe/International" onclick="auto_thema(this.id);"> Europe/International
                </div>

                <div class="grid_100">
                    <div class="label_topic">VOTRE contribution</div>
                    <textarea name="entry.1849195029" id="entry_1849195029" style="width: calc(100% - 42px); height: 200px; margin-bottom: 10px; padding: 20px; font-size: 17px;"></textarea>
                </div>
				<div class="label_topic">Inscriptions</div>
                <div class="checkboxes">
					<input type="hidden" name="inscription_1" value="0" />
					<input type="hidden" name="inscription_2" value="0" />
                    <input type="checkbox" name="inscription_1" id="inscription_1" value="1" checked/>  Je souhaite être informé de la campagne de Christophe Clergeau
                </div>
                <div class="checkboxes">
                    <input type="checkbox" name="inscription_2" id="inscription_2" value="1" />  Je souhaite rejoindre l'équipe et participer à la campagne de Christophe Clergeau
                </div>
                <center><input type="button" class="submit_b" id="button_sb" value="POSTER VOTRE CONTRIBUTION" onclick="valid_formulaire(); return false;"/></center>
                <iframe name="googleform" src="http://www.google.com" style="width: 0px; height: 0px;" frameborder="no"></iframe>
                <input type="hidden" name="entry.1308851286" id="entry_1308851286" value="Economie/emploi"/>
                <input type="hidden" name="draftResponse" value="[]">
                <input type="hidden" name="pageHistory" value="0">
                <input type="hidden" name="fbzx" value="8947972456566108266">
				<div id="ajax_contrib" style="display: none;"></div>
            </form>
        <?php
        }
        elseif($get['type'] == 'defi' && $get['defi'] == 1)
        {
        ?>
            <script type="text/javascript">
                function validateEmail(sEmail) {
                    var filter = /^[\w\-\.\+]+\@[a-zA-Z0-9\.\-]+\.[a-zA-z0-9]{2,4}$/;
                    if (filter.test(sEmail)) {
                        return true;
                    }
                    else {
                        return false;
                    }
                }

                function valid_formulaire()
                {
                    //VERIF CHAMP NOM
                    if($("#entry_797512346").val()=="")
                    {
                        alert('Merci de renseigner votre nom');
                    }
                    else
                    {
                        //VERIF CHAMP PRENOM
                        if($("#entry_1488305638").val()=="")
                        {
                            alert('Merci de renseigner votre prénom');
                        }
                        else
                        {
                            //VERIF CHAMP MAIL
                            var sEmail = $("#entry_16618655").val();
                            if($("#entry_16618655").val()=="" || validateEmail(sEmail) == false)
                            {
                                alert('Merci de renseigner votre adresse e-mail/une adresse e-mail valide');
                            }
                            else
                            {
                                if($("#entry_1849195029").val()=="")
                                {
                                    alert('Votre contribution semble vide, merci de remplir le champs afférent.');
                                }
                                else
                                {
                                    alert('Votre contribution nous a été remise avec succès. Merci et à bientôt.');
                                    document.googleformm.submit();
									
									var url = "ajax_contrib.php";
									var div = "ajax_contrib";
									
									var prenom = $("#entry_1488305638").val();
									var nom = $("#entry_797512346").val();
									var email = $("#entry_16618655").val();
									var thematiques = $("#entry_1308851286").val();
									if($("#inscription_1").is(':checked') == true)
									{
										var inscription_1 = 1;
									}
									else
									{
										var inscription_1 = 0;
									}	
									if($("#inscription_2").is(':checked') == true)
									{
										var inscription_2 = 1;
									}
									else
									{
										var inscription_2 = 0;
									}	
									
									var data = "prenom=" + prenom + "&nom=" + nom + "&email=" + email + "&inscription_1=" + inscription_1 + "&inscription_2=" + inscription_2 + "&thematiques=" + thematiques;
									AAWrite2(url, data, 'div', div);          
                                }

                            }
                        }
                    }
                }
            </script>
            <form action="https://docs.google.com/forms/d/1JbDmx0ae3iOyMtwbgZMU7HNdoPBKly-camJICYbyFtM/formResponse" method="POST" id="ss-form" name="googleformm" target="googleform">
                <div class="label_topic">Coordonnées</div>
                <div class="relatif">
                    <div class="grid_100">
                        <div class="grid_50 left">
                            <input type="text" placeholder="Prénom" value="" name="entry.1488305638" id="entry_1488305638" />
                        </div>
                        <div class="grid_50 right">
                            <input type="text" placeholder="Nom" value="" name="entry.797512346" id="entry_797512346"/>
                        </div>
                    </div>
                </div>

                <div class="grid_100">
                    <div class="label_topic">E-mail *</div>
                    <input type="text" placeholder="Adresse e-mail (obligatoire)" value="" name="entry.16618655" id="entry_16618655"/>
                </div>

                <div class="grid_100">
                    <div class="label_topic">Votre contribution</div>
                    <textarea name="entry.1849195029" id="entry_1849195029" style="width: calc(100% - 42px); height: 200px; margin-bottom: 10px; padding: 20px; font-size: 17px;"></textarea>
                </div>
				<div class="label_topic">Inscriptions</div>
                <div class="checkboxes">
					<input type="hidden" name="inscription_1" value="0" />
					<input type="hidden" name="inscription_2" value="0" />
                    <input type="checkbox" name="inscription_1" id="inscription_1" value="1" checked/>  Je souhaite être informé de la campagne de Christophe Clergeau
                </div>
                <div class="checkboxes">
                    <input type="checkbox" name="inscription_2" id="inscription_2" value="1" />  Je souhaite rejoindre l'équipe et participer à la campagne de Christophe Clergeau
                </div>
                <center><input type="button" class="submit_b" id="button_sb" value="POSTER VOTRE CONTRIBUTION" onclick="valid_formulaire(); return false;"/></center>
                <iframe name="googleform" src="http://www.google.com" style="width: 0px; height: 0px;" frameborder="no"></iframe>
                <input type="hidden" name="entry.1308851286" id="entry_1308851286" value="Economie/emploi"/>
                <input type="hidden" name="draftResponse" value="[]">
                <input type="hidden" name="pageHistory" value="0">
                <input type="hidden" name="fbzx" value="8947972456566108266">
				<div id="ajax_contrib" style="display: none;"></div>
            </form>
        <?php
        }
        elseif($get['type'] == 'defi' && $get['defi'] == 2)
        {
        ?>
            <script type="text/javascript">
                function validateEmail(sEmail) {
                    var filter = /^[\w\-\.\+]+\@[a-zA-Z0-9\.\-]+\.[a-zA-z0-9]{2,4}$/;
                    if (filter.test(sEmail)) {
                        return true;
                    }
                    else {
                        return false;
                    }
                }

                function valid_formulaire()
                {
                    //VERIF CHAMP NOM
                    if($("#entry_797512346").val()=="")
                    {
                        alert('Merci de renseigner votre nom');
                    }
                    else
                    {
                        //VERIF CHAMP PRENOM
                        if($("#entry_1488305638").val()=="")
                        {
                            alert('Merci de renseigner votre prénom');
                        }
                        else
                        {
                            //VERIF CHAMP MAIL
                            var sEmail = $("#entry_16618655").val();
                            if($("#entry_16618655").val()=="" || validateEmail(sEmail) == false)
                            {
                                alert('Merci de renseigner votre adresse e-mail/une adresse e-mail valide');
                            }
                            else
                            {
                                if($("#entry_1849195029").val()=="")
                                {
                                    alert('Votre contribution semble vide, merci de remplir le champs afférent.');
                                }
                                else
                                {
                                    alert('Votre contribution nous a été remise avec succès. Merci et à bientôt.');
                                    document.googleformm.submit();
									
									var url = "ajax_contrib.php";
									var div = "ajax_contrib";
									
									var prenom = $("#entry_1488305638").val();
									var nom = $("#entry_797512346").val();
									var email = $("#entry_16618655").val();
									var thematiques = $("#entry_1308851286").val();
									if($("#inscription_1").is(':checked') == true)
									{
										var inscription_1 = 1;
									}
									else
									{
										var inscription_1 = 0;
									}	
									if($("#inscription_2").is(':checked') == true)
									{
										var inscription_2 = 1;
									}
									else
									{
										var inscription_2 = 0;
									}	
									
									var data = "prenom=" + prenom + "&nom=" + nom + "&email=" + email + "&inscription_1=" + inscription_1 + "&inscription_2=" + inscription_2 + "&thematiques=" + thematiques;
									AAWrite2(url, data, 'div', div);          
                                }

                            }
                        }
                    }
                }

                function auto_thema(id_thema)
                {
                    var thema_clic = "#" + id_thema;
                    if($(thema_clic).is(':checked') == true)
                    {
                        var contenu_thema = $(thema_clic).val();
                        var contenu_final = contenu_thema;
                        $("#entry_1308851286").val(contenu_final);
                    }
                }
            </script>
            <form action="https://docs.google.com/forms/d/1JbDmx0ae3iOyMtwbgZMU7HNdoPBKly-camJICYbyFtM/formResponse" method="POST" id="ss-form" name="googleformm" target="googleform">
                <div class="label_topic">Coordonnées</div>
                <div class="relatif">
                    <div class="grid_100">
                        <div class="grid_50 left">
                            <input type="text" placeholder="Prénom" value="" name="entry.1488305638" id="entry_1488305638" />
                        </div>
                        <div class="grid_50 right">
                            <input type="text" placeholder="Nom" value="" name="entry.797512346" id="entry_797512346"/>
                        </div>
                    </div>
                </div>

                <div class="grid_100">
                    <div class="label_topic">E-mail *</div>
                    <input type="text" placeholder="Adresse e-mail (obligatoire)" value="" name="entry.16618655" id="entry_16618655"/>
                </div>
                <div class="label_topic">Thématiques</div>
                <div class="checkboxes">
                    <input type="radio" name="themachamps" id="thema_1" value="Education supérieure/recherche" onclick="auto_thema(this.id);"> Enseignement supérieur/recherche
                </div>
                <div class="checkboxes">
                    <input type="radio" name="themachamps" id="thema_2" value="Education/formation" onclick="auto_thema(this.id);" checked> Education/formation
                </div>

                <div class="grid_100">
                    <div class="label_topic">Votre contribution</div>
                    <textarea name="entry.1849195029" id="entry_1849195029" style="width: calc(100% - 42px); height: 200px; margin-bottom: 10px; padding: 20px; font-size: 17px;"></textarea>
                </div>
				<div class="label_topic">Inscriptions</div>
					<div class="checkboxes">
					
                    <input type="checkbox" name="inscription_1" id="inscription_1" value="1" checked/>  Je souhaite être informé de la campagne de Christophe Clergeau
                </div>
                <div class="checkboxes">
                    <input type="checkbox" name="inscription_2" id="inscription_2" value="1" />  Je souhaite rejoindre l'équipe et participer à la campagne de Christophe Clergeau
                </div>
                <center><input type="button" class="submit_b" id="button_sb" value="POSTER VOTRE CONTRIBUTION" onclick="valid_formulaire(); return false;"/></center>
                <iframe name="googleform" src="http://www.google.com" style="width: 0px; height: 0px;" frameborder="no"></iframe>
                <input type="hidden" name="entry.1308851286" id="entry_1308851286" value="Education/formation"/>
                <input type="hidden" name="draftResponse" value="[]">
                <input type="hidden" name="pageHistory" value="0">
                <input type="hidden" name="fbzx" value="8947972456566108266">
				<div id="ajax_contrib" style="display: none;"></div>
            </form>
        <?php
        }
        elseif($get['type'] == 'defi' && $get['defi'] == 3)
        {
        ?>
            <script type="text/javascript">
                function validateEmail(sEmail) {
                    var filter = /^[\w\-\.\+]+\@[a-zA-Z0-9\.\-]+\.[a-zA-z0-9]{2,4}$/;
                    if (filter.test(sEmail)) {
                        return true;
                    }
                    else {
                        return false;
                    }
                }

                function valid_formulaire()
                {
                    //VERIF CHAMP NOM
                    if($("#entry_797512346").val()=="")
                    {
                        alert('Merci de renseigner votre nom');
                    }
                    else
                    {
                        //VERIF CHAMP PRENOM
                        if($("#entry_1488305638").val()=="")
                        {
                            alert('Merci de renseigner votre prénom');
                        }
                        else
                        {
                            //VERIF CHAMP MAIL
                            var sEmail = $("#entry_16618655").val();
                            if($("#entry_16618655").val()=="" || validateEmail(sEmail) == false)
                            {
                                alert('Merci de renseigner votre adresse e-mail/une adresse e-mail valide');
                            }
                            else
                            {
                                if($("#entry_1849195029").val()=="")
                                {
                                    alert('Votre contribution semble vide, merci de remplir le champs afférent.');
                                }
                                else
                                {
                                    alert('Votre contribution nous a été remise avec succès. Merci et à bientôt.');
                                    document.googleformm.submit();
									var url = "ajax_contrib.php";
									var div = "ajax_contrib";
									
									var prenom = $("#entry_1488305638").val();
									var nom = $("#entry_797512346").val();
									var email = $("#entry_16618655").val();
									var thematiques = $("#entry_1308851286").val();
									if($("#inscription_1").is(':checked') == true)
									{
										var inscription_1 = 1;
									}
									else
									{
										var inscription_1 = 0;
									}	
									if($("#inscription_2").is(':checked') == true)
									{
										var inscription_2 = 1;
									}
									else
									{
										var inscription_2 = 0;
									}	
									
									var data = "prenom=" + prenom + "&nom=" + nom + "&email=" + email + "&inscription_1=" + inscription_1 + "&inscription_2=" + inscription_2 + "&thematiques=" + thematiques;
									AAWrite2(url, data, 'div', div);          
                                }

                            }
                        }
                    }
                }
            </script>
            <form action="https://docs.google.com/forms/d/1JbDmx0ae3iOyMtwbgZMU7HNdoPBKly-camJICYbyFtM/formResponse" method="POST" id="ss-form" name="googleformm" target="googleform">
                <div class="label_topic">Coordonnées</div>
                <div class="relatif">
                    <div class="grid_100">
                        <div class="grid_50 left">
                            <input type="text" placeholder="Prénom" value="" name="entry.1488305638" id="entry_1488305638" />
                        </div>
                        <div class="grid_50 right">
                            <input type="text" placeholder="Nom" value="" name="entry.797512346" id="entry_797512346"/>
                        </div>
                    </div>
                </div>

                <div class="grid_100">
                    <div class="label_topic">E-mail *</div>
                    <input type="text" placeholder="Adresse e-mail (obligatoire)" value="" name="entry.16618655" id="entry_16618655"/>
                </div>

                <div class="grid_100">
                    <div class="label_topic">Votre contribution</div>
                    <textarea name="entry.1849195029" id="entry_1849195029" style="width: calc(100% - 42px); height: 200px; margin-bottom: 10px; padding: 20px; font-size: 17px;"></textarea>
                </div>
				<div class="label_topic">Inscriptions</div>
               <div class="checkboxes">
                    <input type="checkbox" name="inscription_1" id="inscription_1" value="1" checked/>  Je souhaite être informé de la campagne de Christophe Clergeau
                </div>
                <div class="checkboxes">
                    <input type="checkbox" name="inscription_2" id="inscription_2" value="1" />  Je souhaite rejoindre l'équipe et participer à la campagne de Christophe Clergeau
                </div>
                <center><input type="button" class="submit_b" id="button_sb" value="POSTER VOTRE CONTRIBUTION" onclick="valid_formulaire(); return false;"/></center>
                <iframe name="googleform" src="http://www.google.com" style="width: 0px; height: 0px;" frameborder="no"></iframe>
                <input type="hidden" name="entry.1308851286" id="entry_1308851286" value="Transition énergétique/environnement"/>
                <input type="hidden" name="draftResponse" value="[]">
                <input type="hidden" name="pageHistory" value="0">
                <input type="hidden" name="fbzx" value="8947972456566108266">
				<div id="ajax_contrib" style="display: none;"></div>
            </form>
        <?php
        }
        elseif($get['type'] == 'defi' && $get['defi'] == 4)
        {
        ?>
            <script type="text/javascript">
                function validateEmail(sEmail) {
                    var filter = /^[\w\-\.\+]+\@[a-zA-Z0-9\.\-]+\.[a-zA-z0-9]{2,4}$/;
                    if (filter.test(sEmail)) {
                        return true;
                    }
                    else {
                        return false;
                    }
                }

                function valid_formulaire()
                {
                    //VERIF CHAMP NOM
                    if($("#entry_797512346").val()=="")
                    {
                        alert('Merci de renseigner votre nom');
                    }
                    else
                    {
                        //VERIF CHAMP PRENOM
                        if($("#entry_1488305638").val()=="")
                        {
                            alert('Merci de renseigner votre prénom');
                        }
                        else
                        {
                            //VERIF CHAMP MAIL
                            var sEmail = $("#entry_16618655").val();
                            if($("#entry_16618655").val()=="" || validateEmail(sEmail) == false)
                            {
                                alert('Merci de renseigner votre adresse e-mail/une adresse e-mail valide');
                            }
                            else
                            {
                                if($("#entry_1849195029").val()=="")
                                {
                                    alert('Votre contribution semble vide, merci de remplir le champs afférent.');
                                }
                                else
                                {
                                    alert('Votre contribution nous a été remise avec succès. Merci et à bientôt.');
                                    document.googleformm.submit();
									
									var url = "ajax_contrib.php";
									var div = "ajax_contrib";
									
									var prenom = $("#entry_1488305638").val();
									var nom = $("#entry_797512346").val();
									var email = $("#entry_16618655").val();
									var thematiques = $("#entry_1308851286").val();
									if($("#inscription_1").is(':checked') == true)
									{
										var inscription_1 = 1;
									}
									else
									{
										var inscription_1 = 0;
									}	
									if($("#inscription_2").is(':checked') == true)
									{
										var inscription_2 = 1;
									}
									else
									{
										var inscription_2 = 0;
									}	
									
									var data = "prenom=" + prenom + "&nom=" + nom + "&email=" + email + "&inscription_1=" + inscription_1 + "&inscription_2=" + inscription_2 + "&thematiques=" + thematiques;
									AAWrite2(url, data, 'div', div);          
                                }

                            }
                        }
                    }
                }

                function auto_thema(id_thema)
                {
                    var thema_clic = "#" + id_thema;
                    if($(thema_clic).is(':checked') == true)
                    {
                        var contenu_thema = $(thema_clic).val();
                        var contenu_final = contenu_thema;
                        $("#entry_1308851286").val(contenu_final);
                    }
                }
            </script>
            <form action="https://docs.google.com/forms/d/1JbDmx0ae3iOyMtwbgZMU7HNdoPBKly-camJICYbyFtM/formResponse" method="POST" id="ss-form" name="googleformm" target="googleform">
                <div class="label_topic">Coordonnées</div>
                <div class="relatif">
                    <div class="grid_100">
                        <div class="grid_50 left">
                            <input type="text" placeholder="Prénom" value="" name="entry.1488305638" id="entry_1488305638" />
                        </div>
                        <div class="grid_50 right">
                            <input type="text" placeholder="Nom" value="" name="entry.797512346" id="entry_797512346"/>
                        </div>
                    </div>
                </div>

                <div class="grid_100">
                    <div class="label_topic">E-mail *</div>
                    <input type="text" placeholder="Adresse e-mail (obligatoire)" value="" name="entry.16618655" id="entry_16618655"/>
                </div>
                <div class="label_topic">Thématiques</div>
                <div class="checkboxes">
                    <input type="radio" name="themachamps" id="thema_1" value="Démocratie/vie associative" onclick="auto_thema(this.id);" checked> Démocratie/vie associative
                </div>
                <div class="checkboxes">
                    <input type="radio" name="themachamps" id="thema_2" value="Aménagement du territoire/ruralité" onclick="auto_thema(this.id);"> Aménagement du territoire/ruralité
                </div>
                <div class="checkboxes">
                    <input type="radio" name="themachamps" id="thema_3" value="Transport" onclick="auto_thema(this.id);"> Transport
                </div>

                <div class="grid_100">
                    <div class="label_topic">Votre contribution</div>
                    <textarea name="entry.1849195029" id="entry_1849195029" style="width: calc(100% - 42px); height: 200px; margin-bottom: 10px; padding: 20px; font-size: 17px;"></textarea>
                </div>
				<div class="label_topic">Inscriptions</div>
                <div class="checkboxes">
                    <input type="checkbox" name="inscription_1" id="inscription_1" value="1" checked/>  Je souhaite être informé de la campagne de Christophe Clergeau
                </div>
                <div class="checkboxes">
                    <input type="checkbox" name="inscription_2" id="inscription_2" value="1" />  Je souhaite rejoindre l'équipe et participer à la campagne de Christophe Clergeau
                </div>
                <center><input type="button" class="submit_b" id="button_sb" value="POSTER VOTRE CONTRIBUTION" onclick="valid_formulaire(); return false;"/></center>
                <iframe name="googleform" src="http://www.google.com" style="width: 0px; height: 0px;" frameborder="no"></iframe>
                <input type="hidden" name="entry.1308851286" id="entry_1308851286" value="Démocratie/vie associative"/>
                <input type="hidden" name="draftResponse" value="[]">
                <input type="hidden" name="pageHistory" value="0">
                <input type="hidden" name="fbzx" value="8947972456566108266">
				<div id="ajax_contrib" style="display: none;"></div>
            </form>
        <?php
        }
        elseif($get['type'] == 'defi' && $get['defi'] == 5)
        {
        ?>
            <script type="text/javascript">
                function validateEmail(sEmail) {
                    var filter = /^[\w\-\.\+]+\@[a-zA-Z0-9\.\-]+\.[a-zA-z0-9]{2,4}$/;
                    if (filter.test(sEmail)) {
                        return true;
                    }
                    else {
                        return false;
                    }
                }

                function valid_formulaire()
                {
                    //VERIF CHAMP NOM
                    if($("#entry_797512346").val()=="")
                    {
                        alert('Merci de renseigner votre nom');
                    }
                    else
                    {
                        //VERIF CHAMP PRENOM
                        if($("#entry_1488305638").val()=="")
                        {
                            alert('Merci de renseigner votre prénom');
                        }
                        else
                        {
                            //VERIF CHAMP MAIL
                            var sEmail = $("#entry_16618655").val();
                            if($("#entry_16618655").val()=="" || validateEmail(sEmail) == false)
                            {
                                alert('Merci de renseigner votre adresse e-mail/une adresse e-mail valide');
                            }
                            else
                            {
                                if($("#entry_1849195029").val()=="")
                                {
                                    alert('Votre contribution semble vide, merci de remplir le champs afférent.');
                                }
                                else
                                {
                                    alert('Votre contribution nous a été remise avec succès. Merci et à bientôt.');
                                    document.googleformm.submit();
									
									var url = "ajax_contrib.php";
									var div = "ajax_contrib";
									
									var prenom = $("#entry_1488305638").val();
									var nom = $("#entry_797512346").val();
									var email = $("#entry_16618655").val();
									var thematiques = $("#entry_1308851286").val();
									if($("#inscription_1").is(':checked') == true)
									{
										var inscription_1 = 1;
									}
									else
									{
										var inscription_1 = 0;
									}	
									if($("#inscription_2").is(':checked') == true)
									{
										var inscription_2 = 1;
									}
									else
									{
										var inscription_2 = 0;
									}	
									
									var data = "prenom=" + prenom + "&nom=" + nom + "&email=" + email + "&inscription_1=" + inscription_1 + "&inscription_2=" + inscription_2 + "&thematiques=" + thematiques;
									AAWrite2(url, data, 'div', div);          
                                }

                            }
                        }
                    }
                }

                function auto_thema(id_thema)
                {
                    var thema_clic = "#" + id_thema;
                    if($(thema_clic).is(':checked') == true)
                    {
                        var contenu_thema = $(thema_clic).val();
                        var contenu_final = contenu_thema;
                        $("#entry_1308851286").val(contenu_final);
                    }
                }
            </script>
            <form action="https://docs.google.com/forms/d/1JbDmx0ae3iOyMtwbgZMU7HNdoPBKly-camJICYbyFtM/formResponse" method="POST" id="ss-form" name="googleformm" target="googleform">
                <div class="label_topic">Coordonnées</div>
                <div class="relatif">
                    <div class="grid_100">
                        <div class="grid_50 left">
                            <input type="text" placeholder="Prénom" value="" name="entry.1488305638" id="entry_1488305638" />
                        </div>
                        <div class="grid_50 right">
                            <input type="text" placeholder="Nom" value="" name="entry.797512346" id="entry_797512346"/>
                        </div>
                    </div>
                </div>

                <div class="grid_100">
                    <div class="label_topic">E-mail *</div>
                    <input type="text" placeholder="Adresse e-mail (obligatoire)" value="" name="entry.16618655" id="entry_16618655"/>
                </div>
                <div class="label_topic">Thématiques</div>
                <div class="checkboxes">
                    <input type="radio" name="themachamps" id="thema_1" value="Solidarité/santé" onclick="auto_thema(this.id);" checked> Solidarité/santé
                </div>
                <div class="checkboxes">
                    <input type="radio" name="themachamps" id="thema_2" value="Culture" onclick="auto_thema(this.id);"> Culture
                </div>
                <div class="checkboxes">
                    <input type="radio" name="themachamps" id="thema_3" value="Sport" onclick="auto_thema(this.id);"> Sport
                </div>

                <div class="grid_100">
                    <div class="label_topic">Votre contribution</div>
                    <textarea name="entry.1849195029" id="entry_1849195029" style="width: calc(100% - 42px); height: 200px; margin-bottom: 10px; padding: 20px; font-size: 17px;"></textarea>
                </div>
				<div class="label_topic">Inscriptions</div>
                <div class="checkboxes">
                    <input type="checkbox" name="inscription_1" id="inscription_1" value="1" checked/>  Je souhaite être informé de la campagne de Christophe Clergeau
                </div>
                <div class="checkboxes">
                    <input type="checkbox" name="inscription_2" id="inscription_2" value="1" />  Je souhaite rejoindre l'équipe et participer à la campagne de Christophe Clergeau
                </div>
                <center><input type="button" class="submit_b" id="button_sb" value="POSTER VOTRE CONTRIBUTION" onclick="valid_formulaire(); return false;"/></center>
                <iframe name="googleform" src="http://www.google.com" style="width: 0px; height: 0px;" frameborder="no"></iframe>
                <input type="hidden" name="entry.1308851286" id="entry_1308851286" value="Solidarité/santé"/>
                <input type="hidden" name="draftResponse" value="[]">
                <input type="hidden" name="pageHistory" value="0">
                <input type="hidden" name="fbzx" value="8947972456566108266">
				<div id="ajax_contrib" style="display: none;"></div>
            </form>
        <?php
        }
        elseif($get['type'] == 'contact')
        {
        ?>
            <form action="index.php?type=contact" method="POST" id="ss-form">
                <div class="label_topic"><center><?php echo $error; ?> <?php echo $error_2; ?></center></div>
                <div class="label_topic">Coordonnées</div>
                <div class="relatif">
                    <div class="grid_100">
                        <div class="grid_50 left">
                            <input type="text" placeholder="Prénom" value="" name="prenom" />
                        </div>
                        <div class="grid_50 right">
                            <input type="text" placeholder="Nom" value="" name="nom" />
                        </div>
                    </div>
                    <div class="grid_100">
                        <div class="grid_50 left">
                            <input type="text" placeholder="Code postal (obligatoire)" value="" name="cp" id="recherche_cities_input" onKeyUp="recherche_cities();"/>
							<div id="recherche_cities_block" style="display: none; position: absolute; width: 100%; z-index: 50;"></div>
						</div>
                        <div class="grid_50 right">
                            <input type="text" placeholder="Ville" value="" name="ville" id="recherche_cities_name"/>
                        </div>
                    </div>
                    <div class="grid_100">
                        <input type="text" placeholder="N° de téléphone mobile (facultatif)" value="" name="telephone" />
                    </div>
                </div>

                <div class="grid_100">
                    <div class="label_topic">E-mail *</div>
                    <input type="text" placeholder="Adresse e-mail (obligatoire)" value="" name="email"/>
                </div>

                <div class="grid_100">
                    <div class="label_topic">VOTRE message</div>
                    <textarea name="message" style="width: calc(100% - 42px); height: 200px; margin-bottom: 10px; padding: 20px; font-size: 17px;"></textarea>
                </div>

								<!-- Eric -->

                <div class="label_topic">Inscriptions</div>
                <div class="checkboxes">
                    <input type="checkbox" name="inscription_1" value="1" checked/>  Je souhaite être informé de la campagne de Christophe Clergeau
                </div>
                <div class="checkboxes">
                    <input type="checkbox" name="inscription_2" value="1" checked/>  Je souhaite rejoindre l'équipe et participer à la campagne de Christophe Clergeau
                </div>

                <!-- Eric -->
                
                <center><input type="submit" class="submit_b" id="button_sb" value="ENVOYER"/></center>
            </form>
        <?php
        }
        ?>
        <?php
        }
        else
        {
			if($get['type'] == 'cover' && $get['valid'] != 'ok' && !isset($get['etape']))
			{
        ?>
			<script type="text/javascript">
			function display_select(type, etat)
			{
				var select_to = "#select-" + type;
				var select_base = "#select-text-" + type;
				var new_icon = "url(templates/_forms/select-arrow-white.png) no-repeat right center #ef0d4c";
				$(select_to).slideToggle("fast");
				
				if(etat == 0)
				{
					$(select_base).css('background', '');
					$(select_base).css('color', '');
					$("#button_submit").css('margin-bottom', '');
				}
				else
				{
					$(select_base).css('background', new_icon);
					$(select_base).css('color', '#FFFFFF');
					$("#button_submit").css('margin-bottom', '25px');
				}
			}
			
			function auto_thema(id_thema)
			{
				var thema_clic = "#" + id_thema;
				var contenu_thema = $(thema_clic).val() + ",";
				var contenu_ec = $("#thematiques").val();
				if($(thema_clic).is(':checked') == true)
				{
					var contenu_final = contenu_ec + contenu_thema;
					$("#thematiques").val(contenu_final);
					

				}
				else
				{
					var maChaine = contenu_ec;
					var chaineASupprimer = contenu_thema;
					var maChaine = maChaine.replace(chaineASupprimer, "");
					$("#thematiques").val(maChaine);
					
				}
			}
			</script>
			<div class="label_topic" style="font-size: 10px; margin-bottom: 5px; color: #FFFFFF;"><center>Merci pour votre inscription ! Vous recevrez prochainement un mail de bienvenue. Si vous souhaitez devenir un acteur de cette campagne, nous vous invitons à compléter vos coordonnées et à choisir une thématique.</center></div>
			<form action="index.php?type=cover&etape=3" method="POST">
                    <div class="relatif">
                        <div class="grid_100">
                            <input type="text" class="cover_i" placeholder="N° de téléphone mobile (facultatif)" value="" name="telephone" onclick="display_select('thema', 0);"/>
							<div class="emule-selects emule-selects-larger rounded" id="select-text-thema" onclick="display_select('thema', 1);">
								Veuillez sélectionner une thématique
							</div>
							<div class="emule-select-list emule-select-list-larger" id="select-thema">
								<div class="emule-selects-id"><input type="checkbox" id="thema_1" value="Economie/emploi" onclick="auto_thema(this.id);" style="width: 15px;"/> Economie/emploi</div>
								<div class="emule-selects-id"><input type="checkbox" id="thema_2" value="Education/formation" onclick="auto_thema(this.id);" style="width: 15px;"/>  Education/formation</div>
								<div class="emule-selects-id"><input type="checkbox" id="thema_3" value="Transition énergétique/environnement" onclick="auto_thema(this.id);" style="width: 15px;"/> Transition énergétique/environnement</div>
								<div class="emule-selects-id"><input type="checkbox" id="thema_4" value="Démocratie/vie associative" onclick="auto_thema(this.id);" style="width: 15px;"/> Animer la démocratie, développer les territoires</div>
								<div class="emule-selects-id"><input type="checkbox" id="thema_5" value="Solidarité/santé" onclick="auto_thema(this.id);" style="width: 15px;" /> Vivre ensemble solidaires</div>
								<div class="emule-selects-id"><input type="checkbox" id="thema_6" value="Europe/International" onclick="auto_thema(this.id);" style="width: 15px;"/> Europe/international</div>
							</div>
                        </div>
							
                    </div>
                <center><input type="submit" class="submit_c" id="button_submit" value="JE M'ENGAGE" onclick="display_select('thema', 0);"/></center>
				<input type="hidden" name="thematiques" value="" id="thematiques" />
                <input type="hidden" name="statut" value="1" />
				<input type="hidden" value="<?php echo $post['email']; ?>" name="email"/>
				<input type="hidden" value="<?php echo $post['nom']; ?>" name="nom"/>
				<input type="hidden" value="<?php echo $post['prenom']; ?>" name="prenom"/>
				<input type="hidden" value="<?php echo $post['cp']; ?>" name="cp"/>
				<input type="hidden" value="<?php echo $post['ville']; ?>" name="ville"/>
				<input type="hidden" name="inscription_1" value="1"/>
                <input type="hidden" name="inscription_2" value="1" />
				<input type="hidden" name="go_to_arc" value="0"/>
            </form>
			<?php
			}
			else
			{
			?>
            <div class="label_topic"><center>Merci pour votre inscription, vous recevrez un mail de bienvenue dans les plus brefs délais.</center></div>
        <?php
			}
        }
        ?>
    </div>
<?php include(''.$DIR.'templates/_'.$TEMPLATE.'/includes/footer.inc.php'); ?>
